<?php

namespace web\admin\ap;

class cash_out_apply {
    static function setwhere($db, $post) {
        $query = $post->get('query');
        $csql = new \ciy\sql('ap_cash_out');
        $liid = objint($query, 'liid');
        if ($liid > 0)
            $csql->where('cashstatus', $liid);
        else
            $csql->where('cashstatus=10');
        $val = objstr($query, 'vuser');
        if (!empty($val)) {
            $csqlt = new \ciy\sql('ap_user');
            $csqlt->where('name like', $val);
            $trow = $db->getone($csqlt);
            if (is_array($trow)) {
                $csql->where('vuser', $trow['id']);
                $query['vuser'] = $trow['name'];
            } else {
                $csql->where('vuser=0');
            }
        }
        $csql->where('cashtype', objstr($query, 'cashtype'));
        $csql->wherenumrange('cashmoney', objstr($query, 'cashmoney_1'), objstr($query, 'cashmoney_2'), 100);
        $csql->wheredaterange('addtimes', objstr($query, 'addtimes'));
        $csql->where('cashno like', objstr($query, 'cashno'));
        $order = objstr($query, 'order', 'id desc');
        $csql->order($order);
        $query['order'] = $order;
        return [$query, $csql];
    }

    public static function json_list() {
        global $db;
        $rsuser = verifyfast();
        $post = new \ciy\post();
        list($where, $csql) = self::setwhere($db, $post);
        $pageno = $post->getint('pageno', 1);
        $pagecount = $post->getint('pagecount', 10);
        $csql->limit($pageno, $pagecount);
        $mainrowcount = $post->getint('count');
        $rows = $db->get($csql, $mainrowcount);
        if ($rows === false)
            return errjson($db->error);
        $ret = array('searchwhere' => $where, 'pageno' => $pageno, 'pagecount' => $pagecount, 'count' => $mainrowcount, 'list' => $rows);
        if ($post->getbool('field')) {
            $field = array();
            $fshow = $db->getfield($field, 'ap_cash_out');
            foreach ($field as $fr => $v) {
                if (get('_' . $fr))
                    $field[$fr]['c'] = ',' . $field[$fr]['c'];
            }
            $fshow = fieldadd($fshow, $field, 0, '_btn', '操作');
            $ret['field'] = $field;
            $ret['fshow'] = $fshow;
        }
        if ($post->getbool('once')) {
            $ret['once'] = true;
            $input = array();
            $input[] = array('type' => 'input', 'form' => 'vuser', 'name' => '所属用户', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'select', 'form' => 'cashtype', 'name' => '提现方式', 'all' => '全部', 'select' => '独立纳税.个人微信');
            $input[] = array('type' => 'num', 'form' => 'cashmoney', 'name' => '金额', 'prop' => ' style="width:4em;"');
            $input[] = array('type' => 'daterange', 'form' => 'addtimes', 'name' => '申请时间');
            $input[] = array('type' => 'input', 'form' => 'cashno', 'name' => '支付编号', 'prop' => ' style="width:8em;"');
            $ret['searchinput'] = $input;
        }
        $ret['ap_user'] = getrelation($db, $rows, 'ap_user', 'vuser');
        return succjson($ret);
    }
    public static function json_audit() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p u'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        $act = $post->getint('act');
        $auditmsg = $post->get('auditmsg');
        $ids = $post->get('ids');
        if (empty($ids))
            return errjson('请选择至少一条');
        if ($act == 2) {
            if (empty($auditmsg))
                return errjson('请填写拒绝原因');
        }
        $csql = new \ciy\sql('ap_cash_out');
        $csql->where('id in', $ids);
        $rows = $db->get($csql);
        $ids = array();
        try {
            $db->begin();
            foreach ($rows as $row) {
                if ($row['cashstatus'] != 10)
                    continue;
                if ($act == 2) { //退余额
                    \web\cwebcomon::usercashoe($db, 11, $row['vuser'], $row['cashmoney'], '提现审核拒绝');
                }
                $id = $row['id'];
                $updata = array();
                if ($act == 1) {
                    if ($row['cashtype'] == 1)
                        $updata['cashstatus'] = 50;
                    else
                        $updata['cashstatus'] = 20;
                } else {
                    $updata['cashstatus'] = 90;
                    $updata['auditmsg'] = $auditmsg;
                }
                $csql = new \ciy\sql('ap_cash_out');
                $csql->where('id', $id);
                if ($db->update($csql, $updata) === false)
                    throw new \Exception('更新失败:' . $db->error);
                $updata['id'] = $id;
                $ids[] = $id;
            }
            $db->commit();
        } catch (\Exception $ex) {
            $db->rollback();
            savelogfile('err_db', $ex->getMessage());
            return errjson($ex->getMessage());
        }
        $ret['data'] = $updata;
        $ret['ids'] = $ids;
        return succjson($ret);
    }

    public static function json_del() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p d'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        $ids = $post->get('ids');
        if (empty($ids))
            return errjson('请选择至少一条');
        $csql = new \ciy\sql('ap_cash_out');
        $csql->where('id in', $ids);
        $rows = $db->get($csql);
        $vids = array();
        try {
            $db->begin();
            foreach ($rows as $row) {
                if ($row['cashstatus'] < 90)
                    continue;
                if ($row['addtimes'] > time() - 86400 * 30)
                    continue;
                $delid = $row['id'];
                delme($db, $delid, 'ap_cash_out');
                savelogdb($db, $rsuser['id'], 'ap_cash_out', $row, null);
                $vids[] = $delid;
            }
            $db->commit();
        } catch (\Exception $ex) {
            $db->rollback();
            savelogfile('err_db', $ex->getMessage());
            return errjson($ex->getMessage());
        }
        $ret['ids'] = $vids;
        return succjson($ret);
    }
    public static function json_exportxls() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p e'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        list($where, $csql) = self::setwhere($db, $post);
        $rows = $db->get($csql);
        if (count($rows) > 10000)
            return errjson('将导出' . count($rows) . '条，不建议超过1万条，请筛选缩小范围');
        $fields = array();
        $fields[] = array('style' => 'l', 'width' => 60,  'field' => 'id', 'name' => '行码');
        $fields[] = array('style' => 'c', 'width' => 100,  'field' => 'cashstatus', 'name' => '提现状态');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'vuser', 'name' => '所属用户');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'cashtype', 'name' => '提现方式');
        $fields[] = array('style' => 'r', 'width' => 100,  'field' => 'cashmoney', 'name' => '金额');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'addtimes', 'name' => '申请时间');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'cashtimes', 'name' => '支付时间');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'cashno', 'name' => '支付编号');
        $code_cashstatus = getcatas($db, 'cashstatus');
        $code_vuser = getrelation($db, $rows, 'ap_user', 'vuser', 'id,name');
        $code_cashtype = $db->getdbcodes('ap_cash_out', 'cashtype');
        $datas = array();
        foreach ($rows as $row) {
            $dat = array();
            foreach ($fields as $field) {
                $field = $field['field'];
                $val = isset($row[$field]) ? $row[$field] : '';
                if ($field == 'id')
                    $val = enid($val);
                if ($field == 'cashstatus')
                    $val = ccode($code_cashstatus, $val);
                if ($field == 'vuser')
                    $val = ccode($code_vuser, $val);
                if ($field == 'cashtype')
                    $val = ($val == 1 ? $code_cashtype[0]['name'] : @$code_cashtype[1]['name']);
                if ($field == 'cashmoney')
                    $val = number_format($val / 100, 2);
                if ($field == 'addtimes')
                    $val = ($val == 0 ? '--' : date('Y-m-d H:i', $val));
                if ($field == 'cashtimes')
                    $val = ($val == 0 ? '--' : date('Y-m-d H:i', $val));
                $dat[] = $val;
            }
            $datas[] = $dat;
        }
        $param = array();
        $param['field'] = $fields;
        $param['data'] = $datas;
        $param['sheetname'] = '数据报表';
        $param['titleheight'] = '25'; //列头高度
        $param['landscape'] = true; //横向打印
        $param['fixtopage'] = true; //打印整个工作表
        $param['toptitle'] = 'Demo数据报表';
        $str = \ciy\excel::general_excel_xml($param);
        $filename = '';
        if (empty($filename))
            $filename = date('Y-m-d_H-i-s') . rand(1000, 9999);
        $filename .= '.xls';
        file_put_contents(PATH_WEB . 'ud/tmp/' . $filename, $str);
        return succjson(array('url' => '/ud/tmp/' . $filename));
    }
}
